#include "mapedit.h"

#include <stdarg.h>
#include <stdio.h>
#include <allegro.h>
#include <dpmi.h>
//extern BITMAP *menubmp=NULL, *screenbmp=NULL, *tilebmp=NULL, *oldscreenbmp=NULL;
BITMAP *tilebmp=NULL, *tile[250], *screenbmp=NULL, *layer2=NULL;
PALLETE pallete;
extern FONT *font;

//int Map[1000][1000];

extern struct MapStruct {
   int l1;
   int l2;
} Map[100][100];

extern struct UserStruct {  //Map Tiles and Flags
	int tile;
   int tileOffset;
   int x;
   int y;
   int layer;
   int screenX;
   int screenY;
} User;


void InitEditor()
{
   int TLoopX=0, TLoopY=0, TCounter=0;
   text_mode(-1);
   tilebmp=load_bitmap("GFX\\maptiles.bmp",pallete);
   screenbmp=load_bitmap("GFX\\maptiles.bmp",pallete);
   set_pallete(pallete);

   for(TCounter=0;TCounter<=250;TCounter++)  // Initializes the Tiles
      tile[TCounter]=load_bitmap("GFX\\white.bmp",pallete);      

   LoadMapTiles();  // Loads the map tiles
   LoadFile(); // loads the map file
   DrawMap();
//ClearMap();
//SaveFile();
}

void DrawExtras() // Draws the stuff that tells the user where he is on the map
{
   int TLoopY, TLoopX;
   rect(screen,User.x*16,User.y*16,(User.x+1)*16,(User.y+1)*16,66);
   for(TLoopX=0;TLoopX<19;TLoopX++) {
      blit(tile[TLoopX+User.tileOffset],screen,0,0,TLoopX*16,180,16,16);
   }
   rect(screen,User.tile*16,180,(User.tile+1)*16,196,66);
}

void LoadMapTiles()
{
   int TCounter, TLoopY, TLoopX;

   TCounter=0;
   for(TLoopY=0;TLoopY<176;TLoopY+=16) {  //Puts the tiles into memory
      for(TLoopX=0;TLoopX<314;TLoopX+=16) {
         blit(tilebmp,tile[TCounter],TLoopX,TLoopY,0,0,16,16);
         TCounter+=1;  }
   }
   blit(tilebmp,tile[11],176,0,0,0,16,16);
}

void DrawMap()
{
   int TCounter, TLoopY, TLoopX;

   TCounter=0;
   for(TLoopY=0;TLoopY<=10;TLoopY++) { // displays the map on the screen
      for(TLoopX=0;TLoopX<20;TLoopX++) {
         blit(tile[Map[TLoopX+(User.screenX)][TLoopY+(User.screenY)].l1],screenbmp,0,0,TLoopX*16,TLoopY*16,16,16);  
         masked_blit(tile[Map[TLoopX+(User.screenX)][TLoopY+(User.screenY)].l2],screenbmp,0,0,TLoopX*16,TLoopY*16,16,16); }
   }
   blit(screenbmp,screen,0,0,0,0,320,200);
   ShowMap();
   DrawExtras();
};

void DrawLayer1()
{
   int TCounter, TLoopY, TLoopX;

   TCounter=0;
   for(TLoopY=0;TLoopY<=10;TLoopY++) { // displays the map on the screen
      for(TLoopX=0;TLoopX<20;TLoopX++) {
         blit(tile[Map[TLoopX+(User.screenX)][TLoopY+(User.screenY)].l1],screenbmp,0,0,TLoopX*16,TLoopY*16,16,16); } 
   }
   ShowMap();
   DrawExtras();
};

void DrawLayer2()
{
   int TCounter, TLoopY, TLoopX;

   TCounter=0;
   for(TLoopY=0;TLoopY<=10;TLoopY++) { // displays the map on the screen
      for(TLoopX=0;TLoopX<20;TLoopX++) {
         blit(tile[Map[TLoopX+(User.screenX)][TLoopY+(User.screenY)].l2],screenbmp,0,0,TLoopX*16,TLoopY*16,16,16); }
   }
   ShowMap();
   DrawExtras();
};

void DrawIt()
{
   switch(User.layer)
   {
      case 0:
         DrawMap();
         break;
      case 1:
         DrawLayer1();
         break;
      case 2:
         DrawLayer2();
         break;
   }
};

void ShowMap()
{
blit(screenbmp,screen,0,0,0,0,320,200);
}

void SaveFile() {
	FILE* iFile;
   if ((iFile = fopen("MAP\\MAP.DAT", "wb")) == NULL) /* open file TEST.$$$ */
	{
		fprintf(stderr, "Cannot open output file.\n");
	}
   fwrite(&Map,sizeof(Map),1,iFile);     //Read the entire map into the struct
	fclose(iFile);
};

void LoadFile() {
	FILE* oFile;
   if ((oFile = fopen("MAP\\MAP.DAT", "rb"))  == NULL)
	{
		fprintf(stderr, "Cannot open output file.\n");
	}
   fread(&Map,sizeof(Map),1,oFile);     //Read the entire map into the struct
	fclose(oFile);
DrawMap();
};

void ClearMap()
{
int TLoopY, TLoopX;
   for(TLoopY=0;TLoopY<=100;TLoopY++) { // sets random tile numbers into the map
      for(TLoopX=0;TLoopX<100;TLoopX++) {
//         Map[TLoopX][TLoopY].l1=rand() % 3;  // for random number
//         Map[TLoopX][TLoopY].l2=rand() % 3; } // for random number
           Map[TLoopX][TLoopY].l1=0;  // to set it all to water (tile 0)
           Map[TLoopX][TLoopY].l2=0; } // to set it all to water (tile 0)
   }
DrawMap();
}


